package com.elpuig.androidam.adapters;

import java.util.ArrayList;

import com.elpuig.androidam.core.Student;
import com.elpuig.attendancemanager.R;


import android.app.Activity;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

/**
 * Clase StudentAdapter
 * 
 * Custom ArrayAdapter de estudiantes para los listviews de alumnos 
 * en las clases TeachersMain y Tutor.
 * 
 * 
 * 
 * @author Mario Álvarez <malvarez@iespuigcastellar.xeill.net>
 * @author Adrián García <agarcia2@iespuigcastellar.xeill.net>
 * @author Edgar Moreno <emoreno@iespuigcastellar.xeill.net>
 *
 */
public class StudentAdapter extends ArrayAdapter<Student> {
		 
    private ArrayList<Student> items;
    private Activity activitycontext = null;

    public StudentAdapter(Activity context, int textViewResourceId, ArrayList<Student> items) {
        super(context, textViewResourceId, items);
        activitycontext=context;
        this.items = items;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        View v = convertView;
        if (v == null) {
            LayoutInflater vi = activitycontext.getLayoutInflater();
            v = vi.inflate(R.layout.list_item, null);
        }
        Student student = items.get(position);
        if (student != null) {
            TextView ttitulo = (TextView) v.findViewById(R.id.listname);
            TextView tstate = (TextView) v.findViewById(R.id.stateletter);

            ImageView image = (ImageView) v.findViewById(R.id.icono);
        	Drawable ic = v.getResources().getDrawable(R.drawable.stub);
            Drawable imagenfinal = null;

            byte[] b= student.getPhoto();
            if (b==null){
            	image.setImageDrawable(ic);
           }
           else{
        	   imagenfinal =  new BitmapDrawable(BitmapFactory.decodeByteArray(b, 0, b.length)); 
               
               image.setImageDrawable(imagenfinal);
           }
            
            
            Integer state =student.getState();
            if (ttitulo != null) {
                ttitulo.setText(student.toString());
            }
         if (state!=null){
        	 switch (state){
        	 case 0: v.setBackgroundColor(Color.WHITE);
        	 		tstate.setText("");
        	 		break;
        	 case 1: v.setBackgroundColor(Color.YELLOW);
        	 		tstate.setText("F");
 	 				break;
        	 case 2: v.setBackgroundColor(Color.BLUE);
        			 tstate.setText("R");
 	 				break;
        	 case 3: v.setBackgroundColor(Color.GREEN);
        			 tstate.setText("J");
 	 				break;
        	 case 4: v.setBackgroundColor(Color.RED);
      			  	 tstate.setText("E");
				break;
        	 
        	 }
        	 
         }
            
            
        }
        return v;
    }
}