package com.elpuig.androidam.parsers;

import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class ParserConfirmation
{
    private URL Url;
 
    public ParserConfirmation(String url)
    {
        try
        {
            this.Url = new URL(url);
        }
        catch (MalformedURLException e)
        {
            throw new RuntimeException(e);
        }
    }
 
    public boolean parse()
    {
        //Instanciamos la fábrica para DOM
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        Boolean inf = null;
 
        try
        {
            //Creamos un nuevo parser DOM
            DocumentBuilder builder = factory.newDocumentBuilder();
 
            //Realizamos lalectura completa del XML
            Document dom = builder.parse(this.getInputStream());
 
            //Nos posicionamos en el nodo principal del árbol
            Element root = dom.getDocumentElement();
 
            //Localizamos todos los elementos
            NodeList items = root.getElementsByTagName("confirmation");
 
            //Recorremos la lista
            for (int i=0; i<items.getLength(); i++)
            {
                Boolean aux = null;
 
                //Obtenemos el item actual
                Node item = items.item(i);
 
                //Obtenemos la lista
                NodeList datosItem = item.getChildNodes();
 
                //Procesamos cada dato
                for (int j=0; j<datosItem.getLength(); j++)
                {
                    Node dato = datosItem.item(j);
                    String etiqueta = dato.getNodeName();
 
                    if (etiqueta.equals("correct"))
                    {
                        String texto = obtenerTexto(dato);
                        aux = Boolean.parseBoolean(texto);
                    }
                }
 
                inf = aux;
            }
        }
        catch (Exception ex)
        {
            throw new RuntimeException(ex);
        }
 
        return  inf;
    }
 
    private String obtenerTexto(Node dato)
    {
        StringBuilder texto = new StringBuilder();
        NodeList fragmentos = dato.getChildNodes();
 
        for (int k=0;k<fragmentos.getLength();k++)
        {
            texto.append(fragmentos.item(k).getNodeValue());
        }
 
        return texto.toString();
    }
 
    private InputStream getInputStream()
    {
        try
        {
            return Url.openConnection().getInputStream();
        }
        catch (IOException e)
        {
            throw new RuntimeException(e);
        }
    }
}