package org.iespuigcastellar.attendancemanager.androidservlet;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.iespuigcastellar.attendancemanager.AttendancemanagerApplication;
import org.iespuigcastellar.attendancemanager.core.Classblock;
import org.iespuigcastellar.attendancemanager.core.DatabaseStorage;
import org.iespuigcastellar.attendancemanager.core.Group;
import org.iespuigcastellar.attendancemanager.core.Miss;
import org.iespuigcastellar.attendancemanager.core.SMS;
import org.iespuigcastellar.attendancemanager.core.Student;
import org.iespuigcastellar.attendancemanager.core.Teacher;

/**
 * Servlet implementation class AndroidServlet
 */
public class AndroidServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public AndroidServlet() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		response.setContentType("text/xml");
		PrintWriter out = response.getWriter();
		Teacher user = null;
		DatabaseStorage storage = new DatabaseStorage();
		
		int option = Integer.parseInt(request.getParameter("operation"));
			 
			 switch(option){
			 case 0:
				    user = AttendancemanagerApplication.storage.loginUser(request.getParameter("name"),request.getParameter("password"));
				    if (user!=null){
				    	out.println("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>");
				    	out.println("<login>");
				    	out.println("<user>"+ request.getParameter("name") +"</user>");
				    	out.println("<password>"+ request.getParameter("password") +"</password>");
				    	out.println("<tutor>"+ AttendancemanagerApplication.storage.isTutor(user) +"</tutor>");
				    	out.println("</login>");
				    }
				    else{
				    	out.println("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>");
				    	out.println("<login>");
				    	out.println("<user>null</user>");
				    	out.println("<password>null</password>");
				    	out.println("<tutor>null</tutor>");
				    	out.println("</login>");
				    }
				 break;
			 case 1:
				 user = AttendancemanagerApplication.storage.loginUser(request.getParameter("name"),request.getParameter("password"));
					
				 if (user!=null){
					Collection<Classblock> classblocks;
					SimpleDateFormat formatoDelTexto = new SimpleDateFormat("dd-MM-yyyy");
					String strFecha = request.getParameter("date");
					Date fecha = null;
					try {

					    fecha = formatoDelTexto.parse(strFecha);

					} catch (java.text.ParseException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					
					classblocks = AttendancemanagerApplication.storage.classblocksOfTeacherOnDate(user.getID(),fecha);
					out.println("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" + "<classblocks>");
						for(Iterator<?> it = classblocks.iterator(); it.hasNext(); ) {
							Classblock element = (Classblock) it.next();
							out.println("<classblock>");
							out.println("<id>" + element.getID() + "</id>");
							out.println("<name>" + element.getName() + "</name>");
							out.println("<idgroup>" + element.getIDGroup() + "</idgroup>");
							out.println("<idsubject>" + element.getIDSubject() + "</idsubject>");
							out.println("</classblock>");
						}
					out.println("</classblocks>");
				    }
				    else{
				    	out.println("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" + "<classblocks>");
				    	out.println("<classblock>");
						out.println("<id>null</id>");
						out.println("<name>null</name>");
						out.println("<idgroup>null</idgroup>");
						out.println("<idsubject>null</idsubject>");
						out.println("</classblock>");
				    	out.println("</classblocks>");
				    }
				 
				 break;
			 case 2:
				 user = AttendancemanagerApplication.storage.loginUser(request.getParameter("name"),request.getParameter("password"));
					
				 if (user!=null){
					SimpleDateFormat formatoDelTexto = new SimpleDateFormat("dd-MM-yyyy");
					String strFecha = request.getParameter("date");
					Date fecha = null;
					try {

						  fecha = formatoDelTexto.parse(strFecha);

					} catch (java.text.ParseException e) {
							// TODO Auto-generated catch block
						e.printStackTrace();
					}
					Collection<Student> students;
					students = AttendancemanagerApplication.storage. studentsOfGroup(Integer.parseInt(request.getParameter("idgroup")));
					out.println("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" + "<students>");
						for(Iterator<?> it = students.iterator(); it.hasNext(); ) {
							Student element = (Student) it.next();
							Integer level = 0;

							
							out.println("<student>");
							out.println("<id>" + element.getID() + "</id>");
							out.println("<name>" + element.getName() + "</name>");
							out.println("<surname1>" + element.getSurname1() + "</surname1>");

							
							if (storage.existsMiss(Miss.EXPULSION, fecha, Integer.parseInt(request.getParameter("idclassblock")), element.getID())){
								level=4;
							}
							else if (storage.existsMiss(Miss.DELAY, fecha, Integer.parseInt(request.getParameter("idclassblock")), element.getID())){
								level=2;
							}
							else if (storage.existsMiss(Miss.EXCUSED_MISS, fecha, Integer.parseInt(request.getParameter("idclassblock")), element.getID())){
								level=3;
							}
							else if (storage.existsMiss(Miss.MISS, fecha, Integer.parseInt(request.getParameter("idclassblock")), element.getID())){
								level=1;
							}
							
							if (element.getBytePhotoArray() == null){
								
								out.println("<photoarray>"+ element.getBytePhotoArray() +"</photoarray>");
							}
							else{
								try {
									String a = getHexString(element.getBytePhotoArray());
						
									out.println("<photoarray>"+ a +"</photoarray>");

								} catch (Exception e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
							}
							
							
							out.println("<level>"+ level +"</level>");
							out.println("<smsphone>"+element.getSmsphone()+"</smsphone>");
							out.println("</student>");
						}
					out.println("</students>");
				    }
				    else{
				    	out.println("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" + "<students>");
				    	out.println("<student>");
						out.println("<id>null</id>");
						out.println("<name>null</name>");
						out.println("<surname1>null</surname1>");
						out.println("<level>null</level>");
						out.println("<smsphone>null</smsphone>");
						out.println("</student>");
				    	out.println("</students>");
				    }
				 
				 
				 break;
			 case 3:
				 user = AttendancemanagerApplication.storage.loginUser(request.getParameter("name"),request.getParameter("password"));
					
				 if (user!=null){
					out.println("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" + "<misses>");
					int totalmisses = storage.getCountStudentMisses(Integer.parseInt(request.getParameter("idstudent")), 1);
					int totalexcused = storage.getCountStudentMisses(Integer.parseInt(request.getParameter("idstudent")), 2);
					int totaldelay = storage.getCountStudentMisses(Integer.parseInt(request.getParameter("idstudent")), 3);
					int totalexpulsion = storage.getCountStudentMisses(Integer.parseInt(request.getParameter("idstudent")), 4);
					
					int classblocksmisses = storage.getCountStudentMisses(Integer.parseInt(request.getParameter("idstudent")), 1, Integer.parseInt(request.getParameter("idsubject")));
					int classblocksexcused = storage.getCountStudentMisses(Integer.parseInt(request.getParameter("idstudent")), 2,Integer.parseInt(request.getParameter("idsubject")));
					int classblocksdelay = storage.getCountStudentMisses(Integer.parseInt(request.getParameter("idstudent")), 3,Integer.parseInt(request.getParameter("idsubject")));
					int classblocksexpulsion = storage.getCountStudentMisses(Integer.parseInt(request.getParameter("idstudent")), 4,Integer.parseInt(request.getParameter("idsubject")));
					
					
					
					
					out.println("<classblocksmisses>"+classblocksmisses+"</classblocksmisses>");
					out.println("<classblocksexcused>"+classblocksexcused+"</classblocksexcused>");
					out.println("<classblocksdelay>"+classblocksdelay+"</classblocksdelay>");
					out.println("<classblocksexpulsion>"+classblocksexpulsion+"</classblocksexpulsion>");
					
					
					
					out.println("<totalmisses>"+totalmisses+"</totalmisses>");
					out.println("<totalexcused>"+totalexcused+"</totalexcused>");
					out.println("<totaldelay>"+totaldelay+"</totaldelay>");
					out.println("<totalexpulsion>"+totalexpulsion+"</totalexpulsion>");
					out.println("</misses>");
					 
				 }
				 else{
					 out.println("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" + "<misses>");

						out.println("<classblocksmisses>null</classblocksmisses>");
						out.println("<classblocksexcused>null</classblocksexcused>");
						out.println("<classblocksdelay>null</classblocksdelay>");
						out.println("<classblocksexpulsion>null</classblocksexpulsion>");
						
						
						
						out.println("<totalmisses>null</totalmisses>");
						out.println("<totalexcused>null</totalexcused>");
						out.println("<totaldelay>null</totaldelay>");
						out.println("<totalexpulsion>null</totalexpulsion>");
						out.println("</misses>");
				 }
				 
				 break;
			 case 4:
				 
				 user = AttendancemanagerApplication.storage.loginUser(request.getParameter("name"),request.getParameter("password"));

				 if (user!=null){
					 SMS sms = new SMS();
				
					 boolean bool = sms.sendSMS(request.getParameter("phonenumber"), request.getParameter("msg"));
					 if (bool){
						 out.println("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>");
					    	out.println("<confirmation>");
					    	out.println("<correct>"+ bool +"</correct>");
					    	out.println("</confirmation>");
					 }
					 else{
						 out.println("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>");
					    	out.println("<confirmation>");
					    	out.println("<correct>"+ bool +"</correct>");
					    	out.println("</confirmation>");
						 
					 }
					
				 }
				 else{
					 out.println("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>");
				    	out.println("<confirmation>");
				    	out.println("<correct>"+ false +"</correct>");
				    	out.println("</confirmation>");
					 
				 }
				 
				 break;
			 case 5:
				 	SimpleDateFormat formatoDelTexto = new SimpleDateFormat("dd-MM-yyyy");
					String strFecha = request.getParameter("date");
					Date fecha = null;
					try {

						  fecha = formatoDelTexto.parse(strFecha);

					} catch (java.text.ParseException e) {
							// TODO Auto-generated catch block
						e.printStackTrace();
					}
					
					user = AttendancemanagerApplication.storage.loginUser(request.getParameter("name"),request.getParameter("password"));
					Classblock classblock = storage.getClassblock(Integer.parseInt(request.getParameter("idclassblock")));
					Integer level = Integer.parseInt(request.getParameter("level"));
					Miss miss = null;
					
					
					 if (user!=null){
						
						 
						 System.out.println(level);
						 
						 
						 switch (level) {
							
							case 0:
								storage.deleteMiss(4, fecha, Integer.parseInt(request.getParameter("idstudent")),Integer.parseInt(request.getParameter("idclassblock")));
								break;
							case 1:
							miss =  new Miss(0,1,fecha,"", 
									Integer.parseInt(request.getParameter("idstudent")), 
									classblock.getIDTeacher(), 
									classblock.getIDSubject(), 
									Integer.parseInt(request.getParameter("idclassblock")));
							storage.addMiss(miss);
								break;
							case 2:	

							storage.deleteMiss(1, fecha, Integer.parseInt(request.getParameter("idstudent")),Integer.parseInt(request.getParameter("idclassblock")));
							miss =  new Miss(0,3,fecha,"", 
									Integer.parseInt(request.getParameter("idstudent")), 
									classblock.getIDTeacher(), 
									classblock.getIDSubject(), 
									Integer.parseInt(request.getParameter("idclassblock")));	
							storage.addMiss(miss);
								break;
							case 3:	storage.deleteMiss(3, fecha, Integer.parseInt(request.getParameter("idstudent")),Integer.parseInt(request.getParameter("idclassblock")));
									miss =  new Miss(0,2,fecha,"", 
									Integer.parseInt(request.getParameter("idstudent")), 
									classblock.getIDTeacher(), 
									classblock.getIDSubject(), 
									Integer.parseInt(request.getParameter("idclassblock")));
								storage.addMiss(miss);
								break;
							case 4:	
								storage.deleteMiss(2, fecha, Integer.parseInt(request.getParameter("idstudent")),Integer.parseInt(request.getParameter("idclassblock")));
								miss = new Miss(0,4,fecha,"", 
										Integer.parseInt(request.getParameter("idstudent")), 
										classblock.getIDTeacher(), 
										classblock.getIDSubject(), 
										Integer.parseInt(request.getParameter("idclassblock")));
								storage.addMiss(miss);				
								break;
							
							}
						 Boolean exist = false;
						 
						 
						 if (level !=0){
							 exist = storage.existsMiss(miss.getType(), miss.getDate(), miss.getIDClassblock(), miss.getIDStudent());
							 if (exist==true){
								 out.println("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" + "<confirmation>");
								 out.println("<correct>" + exist + "</correct>");
								 out.println("</confirmation>");
							 }
							 else{
								 out.println("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" + "<confirmation>");
								 out.println("<correct>" + exist + "</correct>");
								 out.println("</confirmation>");
							 }
						 }
						 else{
							 exist=true;
							 out.println("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" + "<confirmation>");
							 out.println("<correct>" + exist + "</correct>");
							 out.println("</confirmation>");
							 
						 }
						 }
				 
				 break;
			 case 6:
				 user = AttendancemanagerApplication.storage.loginUser(request.getParameter("name"),request.getParameter("password"));
					
				 if (user!=null & storage.isTutor(user)){
					 Collection<Group> groups;
					
					 groups = storage.allGroups(user);
					 out.println("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" + "<groups>");
						for(Iterator<?> it = groups.iterator(); it.hasNext(); ) {
							Group element = (Group) it.next();
							out.println("<group>");
							out.println("<id>" + element.getID() + "</id>");
							out.println("<name>" + element.getName() + "</name>");
							out.println("</group>");
						}
					out.println("</groups>");
					 
					 
				 }
				 else{
					 out.println("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" + "<groups>");
					 	out.println("<group>");
						out.println("<id>" + null + "</id>");
						out.println("<name>" + null + "</name>");
						out.println("</group>");
						out.println("</groups>");
					 
				 }
				 
				 
				 break;
			 case 7:
				 user = AttendancemanagerApplication.storage.loginUser(request.getParameter("name"),request.getParameter("password"));
					
				 if (user!=null){
					Collection<Student> students;
					students = AttendancemanagerApplication.storage. studentsOfGroup(Integer.parseInt(request.getParameter("idgroup")));
					out.println("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" + "<students>");
						for(Iterator<?> it = students.iterator(); it.hasNext(); ) {
							Student element = (Student) it.next();
							Integer state = 0;

							
							out.println("<student>");
							out.println("<id>" + element.getID() + "</id>");
							out.println("<name>" + element.getName() + "</name>");
							out.println("<surname1>" + element.getSurname1() + "</surname1>");
							out.println("<level>"+ state +"</level>");
							
							if (element.getBytePhotoArray() == null){
								
								out.println("<photoarray>"+ element.getBytePhotoArray() +"</photoarray>");
							}
							else{
								try {
									String a = getHexString(element.getBytePhotoArray());
						
									out.println("<photoarray>"+ a +"</photoarray>");

								} catch (Exception e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
							}
							
							
							
							
							out.println("<smsphone>"+element.getSmsphone()+"</smsphone>");
							out.println("</student>");
						}
					out.println("</students>");
				    }
				    else{
				    	out.println("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" + "<students>");
				    	out.println("<student>");
						out.println("<id>null</id>");
						out.println("<name>null</name>");
						out.println("<surname1>null</surname1>");
						out.println("<level>null</level>");
						out.println("<smsphone>null</smsphone>");
						out.println("</student>");
				    	out.println("</students>");
				    }
				 
				 break;

			 }
			 
		 
	}

	/**
	 * Metodo que convierte un array de bytes a un String hexadecimal
	 * 
	 * @param b
	 * @return
	 * @throws Exception
	 */
	public static String getHexString(byte[] b) throws Exception {
		  String result = "";
		  for (int i=0; i < b.length; i++) {
		    result +=
		          Integer.toString( ( b[i] & 0xff ) + 0x100, 16).substring( 1 );
		  }
		  return result;
		}
	
	
	
	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
	}

}
